
// +----------------------------------------------------------------------------------------+ //
// |                                       XARD ABHA OBOS  \/                              | //
// |                            Knowledge of the ancients ( )                             | //
// |_________________________________________________o0o___(_)___o0o________________________| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                XARD777 | //
// |----------------------------------------------------------------------------------------| //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 226 (current version)                              | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 White
#property indicator_color2 Magenta//Gold
#property indicator_color3 Magenta//Gold
#property indicator_color4 White
#property indicator_color5 White
#property indicator_color6 Tomato
#property indicator_color7 CLR_NONE//Tomato
#property indicator_color8 CLR_NONE//Aqua

string gs_76 = "ABHAFXS_Timing";
string gs_unused_84 = "V1.00";
int gi_92 = 123;
int gi_96 = 0;
int gi_unused_100 = 0;
double gd_104 = 1.618;
int gi_unused_112 = 1102;
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];
double g_ibuf_132[];
double g_ibuf_136[];
double g_ibuf_140[];
double g_ibuf_144[];
double gda_unused_148[];
double gda_152[10][10];
double gda_156[10];
double gda_160[10];
double gda_164[20];
double gd_168;
int g_period_176;
int gi_180;
double gd_184;
double gd_192;
double gd_200;
int gi_208;
int gi_212;
int gi_216;
int gi_220;
int gi_224;
double gd_228;

int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_116);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, g_ibuf_120);
   SetIndexEmptyValue(0, 0.0);
   SetIndexShift(0, 0);
   SetIndexLabel(0, "UPPER_LINE");
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, g_ibuf_124);
   SetIndexEmptyValue(0, 0.0);
   SetIndexShift(0, 0);
   SetIndexLabel(0, "LOWER_LINE");
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, g_ibuf_128);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexBuffer(4, g_ibuf_132);
   SetIndexStyle(5, DRAW_HISTOGRAM);
   SetIndexBuffer(5, g_ibuf_136);
   SetIndexStyle(6, DRAW_HISTOGRAM);
   SetIndexBuffer(6, g_ibuf_140);
   SetIndexStyle(7, DRAW_HISTOGRAM);
   SetIndexBuffer(7, g_ibuf_144);
   SetIndexEmptyValue(0, 0.0);
   SetIndexShift(0, 0);
   SetIndexLabel(0, "SIGNAL_LINE");
   IndicatorShortName(gs_76);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1.0);
   g_period_176 = MathRound(gi_92);
   gi_224 = gi_96 + 1;
   return (0);
}

int deinit() {
   ObjectsDeleteAll(EMPTY, OBJ_LABEL);
   return (0);
}

int start() {
   int l_index_0;
   double l_iatr_12;
   double l_iatr_20;
   double ld_28;
   int l_ind_counted_4 = IndicatorCounted();
   g_period_176 = gi_92;
   gda_164[1] = g_period_176 + 1;
   SetIndexDrawBegin(0, Bars - g_period_176 - 1);
   SetIndexDrawBegin(1, Bars - g_period_176 - 1);
   SetIndexDrawBegin(2, Bars - g_period_176 - 1);
   SetIndexDrawBegin(3, Bars - g_period_176 - 1);
   SetIndexDrawBegin(4, Bars - g_period_176 - 1);
   SetIndexDrawBegin(5, Bars - g_period_176 - 1);
   SetIndexDrawBegin(6, Bars - g_period_176 - 1);
   SetIndexDrawBegin(7, Bars - g_period_176 - 1);
   for (int li_8 = 1; li_8 <= gi_224 * 2 - 2; li_8++) {
      gd_168 = 0;
      for (gi_180 = l_index_0; gi_180 <= l_index_0 + g_period_176; gi_180++) gd_168 += MathPow(gi_180, li_8);
      gda_164[li_8 + 1] = gd_168;
   }
   for (li_8 = 1; li_8 <= gi_224; li_8++) {
      gd_168 = 0.0;
      for (gi_180 = l_index_0; gi_180 <= l_index_0 + g_period_176; gi_180++) {
         if (li_8 == 1) gd_168 += Close[gi_180];
         else gd_168 += Close[gi_180] * MathPow(gi_180, li_8 - 1);
      }
      gda_156[li_8] = gd_168;
   }
   for (gi_212 = 1; gi_212 <= gi_224; gi_212++) {
      for (gi_208 = 1; gi_208 <= gi_224; gi_208++) {
         gi_216 = gi_208 + gi_212 - 1;
         gda_152[gi_208][gi_212] = gda_164[gi_216];
      }
   }
   for (gi_216 = 1; gi_216 <= gi_224 - 1; gi_216++) {
      gi_220 = 0;
      gd_192 = 0;
      for (gi_208 = gi_216; gi_208 <= gi_224; gi_208++) {
         if (MathAbs(gda_152[gi_208][gi_216]) > gd_192) {
            gd_192 = MathAbs(gda_152[gi_208][gi_216]);
            gi_220 = gi_208;
         }
      }
      if (gi_220 == 0) return (0);
      if (gi_220 != gi_216) {
         for (gi_212 = 1; gi_212 <= gi_224; gi_212++) {
            gd_200 = gda_152[gi_216][gi_212];
            gda_152[gi_216][gi_212] = gda_152[gi_220][gi_212];
            gda_152[gi_220][gi_212] = gd_200;
         }
         gd_200 = gda_156[gi_216];
         gda_156[gi_216] = gda_156[gi_220];
         gda_156[gi_220] = gd_200;
      }
      for (gi_208 = gi_216 + 1; gi_208 <= gi_224; gi_208++) {
         gd_184 = gda_152[gi_208][gi_216] / gda_152[gi_216][gi_216];
         for (gi_212 = 1; gi_212 <= gi_224; gi_212++) {
            if (gi_212 == gi_216) gda_152[gi_208][gi_212] = 0;
            else gda_152[gi_208][gi_212] = gda_152[gi_208][gi_212] - gd_184 * gda_152[gi_216][gi_212];
         }
         gda_156[gi_208] = gda_156[gi_208] - gd_184 * gda_156[gi_216];
      }
   }
   gda_160[gi_224] = gda_156[gi_224] / gda_152[gi_224][gi_224];
   for (gi_208 = gi_224 - 1; gi_208 >= 1; gi_208--) {
      gd_200 = 0;
      for (gi_212 = 1; gi_212 <= gi_224 - gi_208; gi_212++) {
         gd_200 += (gda_152[gi_208][gi_208 + gi_212]) * (gda_160[gi_208 + gi_212]);
         gda_160[gi_208] = 1 / gda_152[gi_208][gi_208] * (gda_156[gi_208] - gd_200);
      }
   }
   for (gi_180 = l_index_0; gi_180 <= l_index_0 + g_period_176; gi_180++) {
      gd_168 = 0;
      for (gi_216 = 1; gi_216 <= gi_96; gi_216++) gd_168 += (gda_160[gi_216 + 1]) * MathPow(gi_180, gi_216);
      g_ibuf_116[gi_180] = gda_160[1] + gd_168;
   }
   gd_228 = 0.0;
   for (gi_180 = l_index_0; gi_180 <= l_index_0 + g_period_176; gi_180++) gd_228 += MathPow(Close[gi_180] - g_ibuf_116[gi_180], 2);
   gd_228 = MathSqrt(gd_228 / (g_period_176 + 1)) * gd_104;
   for (gi_180 = l_index_0; gi_180 <= l_index_0 + g_period_176; gi_180++) {
      g_ibuf_120[gi_180] = g_ibuf_116[gi_180] + gd_228;
      g_ibuf_124[gi_180] = g_ibuf_116[gi_180] - gd_228;
      l_iatr_12 = iATR(Symbol(), 0, 2, 0);
      l_iatr_20 = iATR(Symbol(), 0, g_period_176, 0);
      ld_28 = l_iatr_20 / l_iatr_12;
      if (Digits == 2) {
         g_ibuf_136[gi_180] = NormalizeDouble(g_ibuf_120[gi_180] - ld_28 * l_iatr_20 / 2.0, Digits);
         g_ibuf_140[gi_180] = NormalizeDouble(g_ibuf_124[gi_180] + ld_28 * l_iatr_20 / 2.0, Digits);
      } else {
         if (Digits == 4) {
            g_ibuf_136[gi_180] = NormalizeDouble(g_ibuf_120[gi_180] - ld_28 * l_iatr_20 / 3.0, Digits);
            g_ibuf_140[gi_180] = NormalizeDouble(g_ibuf_124[gi_180] + ld_28 * l_iatr_20 / 3.0, Digits);
         } else {
            g_ibuf_136[gi_180] = NormalizeDouble(g_ibuf_120[gi_180] - ld_28 * l_iatr_20 / 1.5, Digits);
            g_ibuf_140[gi_180] = NormalizeDouble(g_ibuf_124[gi_180] + ld_28 * l_iatr_20 / 1.5, Digits);
         }
      }
   }
   int li_36 = Bars - l_ind_counted_4;
   if (l_ind_counted_4 > 0) li_36++;
   for (l_index_0 = 0; l_index_0 < li_36; l_index_0++) g_ibuf_144[l_index_0] = NormalizeDouble((High[l_index_0] + Low[l_index_0]) / 2.0, Digits);
   return (0);
}